unit Question2U_MEMO;

{*** SOLUTION: Q2.2 ***}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus,
  uQuest2_MEMO; 

type
  TfrmQ2 = class(TForm)
    mnuMain: TMainMenu;
    mnuOptionA: TMenuItem;
    mnuQuit: TMenuItem;
    redQ2: TRichEdit;
    procedure mnuQuitClick(Sender: TObject);
    procedure mnuOptionAClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQ2: TfrmQ2;

  arrTours : Array[1..50] of TData;
  iCount   : Integer = 0;

implementation

{$R *.dfm}
{$R+}

procedure TfrmQ2.FormCreate(Sender: TObject);
var
   TF                  : TextFile;
   sLineA, sLineB      : String;
   sGName, sDName, sMnth, sDays, sNumT : String;
begin
   {Code for onCreate event of form}
   randomize;
   IF NOT FileExists('DataQ2.txt')
    then
     begin
       MessageDlg('ERROR: File not found.', mtError, [mbOk], 0);
       mnuOptionA.Enabled := False;
       Exit;
     end;

   AssignFile(TF, 'DataQ2.txt');
   Reset(TF);
   While NOT EOF(TF) DO
    Begin
      Readln(TF, sLineA);
      Readln(TF, sLineB);

      sGName := copy(sLineA, 1, pos('&', sLineA)-1);
      sDName := copy(sLineA, pos('&', SlineA)+1, length(sLineA));

      sMnth  := copy(sLineB, 1, pos(' for ', sLineB) -1);
      Delete(sLineB, 1, pos('for', sLineB)+3); //delete space after for also
      sDays  := copy(sLineB, 1, pos(' ', sLineB)-1);
      Delete(sLineB, 1, pos('#', sLineB));
      sNumT  := sLineB;

      Inc(iCount, 1);
      arrTours[iCount] := TData.Create(sGName, sDName, sMnth, StrtoInt(sDays), StrToInt(sNumt));
    End; //while
   CloseFile(TF);
end;

procedure TfrmQ2.mnuOptionAClick(Sender: TObject);
var
   sMnth, sLucy                          : String;
   a, iTNum                              : Integer;
   rNTariff                              : Real;
   cLChar                                : Char;
begin
  {Code Option A}
  sMnth := INPUTBOX('Question 2', 'Enter month of tour?', 'February');
  redQ2.Lines.Clear;
  redQ2.Paragraph.TabCount := 1;
  redQ2.Paragraph.Tab[0]   := 100;
  redQ2.Lines.Add('Tours for the month of ' + sMnth);
  redQ2.Lines.Add('=========================');
  redQ2.Lines.Add('Number' + #9 + 'Destination');
  for a := 1 to iCount do
   begin
     if Uppercase(arrTours[a].getMName) = Uppercase(sMnth)
      then redQ2.Lines.Add(intToStr(a) + #9 + arrTours[a].getDName);
   end;

  iTNum := StrtoInt(InputBox('Question 2', 'Enter the number of a tour from the list', '35'));
  redQ2.Lines.Add('');
  redQ2.Lines.Add(arrTours[iTNum].toString);

  redQ2.Lines.Add(' ');
  sLucy := InputBox('Question 2', 'Enter any character from '+
            arrTours[iTNum].getDName +' .', 'a');
  cLChar := arrTours[iTNum].findLuckyChar;      
  IF Upcase(cLChar) = UpCase(sLucy[1])
   then
    begin
      rNTariff := arrTours[iTNum].getTariff * 0.75; //25% discount
      redQ2.Lines.Add('Congratulations! You have received 25% discount '+
                      'on the daily tariff!' + #13 +
                      'The tariff was ' +
          FloatToStrF(arrTours[iTNum].getTariff, ffCurrency, 8,2) +
                      ' per day. It has been reduced to ' +
          FloattoStrF(rNTariff, ffCurrency, 8, 2) + ' per day');
    end
   else
    begin
      redQ2.Lines.Add('The lucky character was the letter '+ cLChar +'.' + #13 +
                      'No discount. The tariff is still ' +
          FloatToStrF(arrTours[iTNum].getTariff, ffCurrency, 8,2) + ' per day');
    end;
end;

procedure TfrmQ2.mnuQuitClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
