unit uQuest2_MEMO;

{*** Solution for Question 2.1 ***}

interface

TYPE
   TData = class(TObject)
     private
        fGName       : String;
        fDName       : String;
        fMName       : String;
        fNumD        : Integer;
        fNumT        : Integer;
        fTariff      : Real;
     public
         function getGName : String;
         function getDName : String;
         function getMName : String;
         function getNumD  : Integer;
         function getNumT  : Integer;
         function getTariff: Real;

         constructor Create(sGuide, sDestination, sMonth: String; iDays, iNum : Integer);
         procedure setTariff;
         function shortenString : String;
         function findLuckyChar : Char;
         function toString : String;
     end;


implementation

uses SysUtils;

{ TData }


constructor TData.Create(sGuide, sDestination, sMonth: String; iDays, iNum: Integer);
begin
   fGName       := sGuide;
   fDName       := sDestination;
   fMName       := sMonth;
   fNumD        := iDays;
   fNumT        := iNum;
   setTariff;
end;

procedure TData.setTariff;
var
  sMonth : String;
begin
  sMonth := Uppercase(fMName); 
  iF (sMonth = 'APRIL') OR (sMonth = 'SEPTEMBER') OR (sMonth = 'DECEMBER')
    then
       fTariff := 1250.00
    else
     iF (sMonth = 'MARCH') OR (sMonth = 'MAY') OR (sMonth = 'JUNE') OR (sMonth = 'JULY')
     then
        fTariff := 900.00
     else
        fTariff := 1000.00;
end;

function TData.shortenString: String;
var
   a : Integer;
   sTemp  : String;
begin
   sTemp := fMName[1];
   for a := 2 to length(fMName) do
    if NOT(Upcase(fMName[a]) in ['A','E','I','O','U'])
     then sTemp := sTemp + fMName[a];

   Result := sTemp;
end;

function TData.toString: String;
begin
   Result := 'Month: ' + shortenString + #13 +
             'Destination: ' + fDName + ' with ' + fGName + ' as the tour guide' + #13 +
             'Price: ' + FloatToStrF(fTariff, ffCurrency, 9,2) + ' per day for a period of '+ IntToStr(fNumD) + ' days'+
             #13+InttoStr(fNumT) + ' tourists are taking this tour.';
end;

function TData.findLuckyChar: Char;
var
 iMax, iLuckyNum : Integer;
begin
  iMax := length(fDName);
  Repeat
    iLuckyNum := random(iMax)+1;
  Until fDName[iLuckyNum] <> #32;

  Result := fDName[iLuckyNum];
end;

function TData.getGName: String;
begin
   Result := fGName;
end;

function TData.getDName: String;
begin
   Result := fDName;
end;

function TData.getMName: String;
begin
   Result := fMName;
end;

function TData.getNumD: Integer;
begin
   Result := fNumD;
end;

function TData.getNumT: Integer;
begin
   Result := fNumT;
end;

function TData.getTariff: Real;
begin
   Result := fTariff;
end;


end.
