unit Question3U_MEMO;

{*** A solution for Question 3 ***}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus;

type
  TfrmQ3 = class(TForm)
    mnuMain: TMainMenu;
    mnuOptionA: TMenuItem;
    mnuOptionB: TMenuItem;
    mnuQuit: TMenuItem;
    redQ3: TRichEdit;
    mnuOptionC: TMenuItem;
    procedure mnuQuitClick(Sender: TObject);
    procedure mnuOptionAClick(Sender: TObject);
    procedure mnuOptionBClick(Sender: TObject);
    procedure mnuOptionCClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQ3: TfrmQ3;

  arrData : Array[1..40] of String =
  ('Rachel Delarosa@Canada#SH#11861','Corradino Grande@Spain#RO#5788', 
'Lucas Herder@Germany#KR#7709', 'Estotz Lizarazu@France#GA#12349', 
'Chynna Taylor@England#GA#8551', 'Renata Di@Spain#RO#4906', 
'Ugs Boulot-Tolle@France#CA#7300', 'Lena Bucholtz@Germany#GA#10344', 
'Maria Heimpel@Germany#SH#9438', 'Julian Amstadter@Germany#RO#8840', 
'Sofie Mosbauer@Germany#GA#5894', 'Fiona Green@England#CA#9094', 
'Sara Escobedo@Canada#KR#4381', 'Nataly Mahan@Canada#RO#12642', 
'Wyatt Parham@Canada#SH#4799', 'Noah Donovan@Canada#SH#3888', 
'Joseph Scott@England#SH#7928', 'Emily Smith@England#KR#3110', 
'Adriana Mancuso@Spain#RO#3724', 'Cassandra Wilder@Canada#KR#12583', 
'Tomasino Camporese@Spain#KR#6777', 'Stacy Anderson@England#RO#3686', 
'Guiraud Bluteau@France#RO#11592', 'Damian Friedman@Canada#RO#9012', 
'Anne Loef@Germany#KR#13035', 'Terence Brown@England#SH#8180', 
'Lion Ghislieri@Spain#RO#14343', 'Giraudetz Girardin@France#CA#11644', 
'Guglielmo Capriati@Spain#SH#5408', 'David Geiberger@Germany#RO#9854', 
'Irisa Cooper@England#KR#11456', 'Hayden Mcdonough@Canada#KR#7840', 
'Jonas Hipp@Germany#RO#3137', 'Emily Kohler@Germany#GA#6509', 
'Emily Thul@Germany#RO#8551', 'Gino Lazzaretti@Spain#CA#2329', 
'Alex Hofstater@Germany#GA#6751', 'Peers Scott@England#RO#9470', 
'Liliana Horne@Canada#RO#14689', 'Leon Kleinpaul@Germany#RO#15194');

implementation

VAR
  //array used for Option 3.
  arrDest  : array[1..6] of string =
           ('Cape Winelands','Garden Route','Kruger National Park',
            'Robben Island (English tour)', 'Robben Island (Other tour)',
            'Shakaland');

{$R *.dfm}
{$R+}

procedure TfrmQ3.mnuOptionAClick(Sender: TObject);
var
   a               : Integer;
   rRand, rTotal   : Real;
   sTemp            : String;
begin
  {Code Option A}
  redQ3.Lines.Clear;
  rTotal := 0;
  for A := 1 to 40 do
   begin
      IF ((pos('France', arrData[a]) > 0) OR (pos('Germany', arrData[a]) > 0)
           OR (pos('Spain', arrData[a]) > 0))
       then
        begin
          sTemp := arrData[a];
          Delete(sTemp, 1, pos('#', sTemp));
          Delete(sTemp, 1, pos('#', sTemp));
          rTotal := rTotal + StrToFloat(sTemp);
        end;
   end;
   rRand := rTotal * 10.75;
   redQ3.Lines.Add('Total amount in euro: '+ FloatToStr(rTotal));
   redQ3.Lines.Add('Total amount in South African rand: ' +
                          FloatToStrF(rRand, ffCurrency, 8, 2));
end;

procedure TfrmQ3.mnuOptionBClick(Sender: TObject);
var
   a, Index               : Integer;
begin
  {Code Option B}
  redQ3.Lines.Clear;
  redQ3.Lines.Add('List of English-speaking tourists to Robben Island:');
  redQ3.Lines.Add('=====================================');
  for a := 1 to 40 do
   begin
     if pos('#RO#', arrData[a]) > 0
      then
       begin
         Index := pos('#RO#', arrData[a]);
         IF (pos('Canada', arrData[a]) > 0) OR
            (pos('England', arrData[a]) > 0)
            then
             begin
                Delete(arrData[a], Index, 4);
                Insert('#ROEnglish#', arrData[a], Index);
                //Insert('English', arrData[a], Index+4); //alternative
                redQ3.Lines.Add(Copy(arrData[a], 1, pos('@', arrData[a])-1));
             end //canada & england
            else
             begin
                Delete(arrData[a], Index, 4);
                Insert('#ROOther#', arrData[a], Index);
                //Insert('Other', arrData[a], Index+4); //alternative
             end;
       end; //robben island
   end;
end;

procedure TfrmQ3.mnuOptionCClick(Sender: TObject);
  {Code Option C}
var
  arrCount :array[1..6] of integer;
  a, b,iRating  :integer;
  sDest :string;
  sRating      :string;           
begin
  redQ3.Lines.Clear;
  redQ3.Paragraph.TabCount := 2;
  redQ3.Paragraph.Tab[0]   := 150;
  redQ3.Paragraph.Tab[1]   := 200;
  redQ3.Lines.Add('Star rating of tours');
  redQ3.Lines.Add('======================================');
  redQ3.Lines.Add('Name' + #9 + 'Rating' + #9 + 'Number of tourists');
  redQ3.Lines.Add('======================================');
  for a := 1 to 6 do
    arrCount[a] := 0;

  for a := 1 to 40 do
    begin
      sDest := Uppercase(copy(arrData[a], pos('#',arrData[a])+1,3));
      case sDest[1] of
        'C' : inc(arrCount[1],1);
        'G' : inc(arrCount[2],1);
        'K' : inc(arrCount[3],1);
        'R' : case sDest[3] of
               'E' : inc(arrCount[4],1);
               'O' : inc(arrCount[5],1);
              end;
        'S' : inc(arrCount[6],1);
      end;
    end;//FOR 40
  For a := 1 to 6 do
    begin
      sRating := '';
      iRating := arrCount[a] div 3;
      for b := 1 to iRating do
         sRating := sRating + '*';
      redQ3.Lines.Add(arrDest[a] + #9 + sRating + #9 + '(' +
                                 IntToStr(arrCount[a]) + ')');
   end;//DISPLAY
end;

procedure TfrmQ3.mnuQuitClick(Sender: TObject);
begin
   Application.Terminate;
end;

end.
