unit Question2_UMemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,RelayEvent_UMemo, StdCtrls, ExtCtrls, ComCtrls,StrUtils;

type
  TfrmQuestion2 = class(TForm)
    grpHeading: TGroupBox;
    grpQ21: TGroupBox;
    grpQ23: TGroupBox;
    grpQ22: TGroupBox;
    grpOutput: TGroupBox;
    btnDisplayCurrentHolder: TButton;
    btnRecordStatus: TButton;
    btnValidateTime: TButton;
    edtTeam: TEdit;
    edtTime: TEdit;
    lblTeam: TLabel;
    lblTime: TLabel;
    lblHeading: TLabel;
    redOutput: TRichEdit;
    btnClose: TButton;
    procedure btnDisplayCurrentHolderClick(Sender: TObject);
    procedure btnRecordStatusClick(Sender: TObject);
    procedure btnValidateTimeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCheckStatus(Sender:TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion2: TfrmQuestion2;
  Boys19Relay : TRelayEvent;

implementation

{$R *.dfm}
procedure TfrmQuestion2.FormCreate(Sender: TObject);
begin
   Boys19Relay := TRelayEvent.Create('4x100m Boys u/19 ','Bristol House', '2009', 41.13);
end;


procedure TfrmQuestion2.btnDisplayCurrentHolderClick(Sender: TObject);
begin
    //Question 2.2.1
  redOutput.Clear;
  redOutput.lines.add(Boys19Relay.ToString);
  btnValidateTime.Enabled := true;
end;



procedure TfrmQuestion2.btnValidateTimeClick(Sender: TObject);
var
  sTeam : String;
  rNewTime : Real;
  btnCheckRecord : TButton;
  iCharCounter : integer;
begin
  //Question 2.2.2
  if (edtTime.Text = '') then   //check edtTime is not empty
  begin
      MessageDlg('The Time box should not be empty.',mtError, [mbOk], 0);
      Exit;
  end
  else
  begin
       for iCharCounter := 1 to length(edtTime.Text) do //check all chars are digits and accept a fullstop for decimal numbers
       begin
            if NOT(edtTime.Text[iCharCounter] IN ['0'..'9','.']) then //each digit of the edtTime is tested against digits regex..
            begin
                //if one non digit character is found
                //then it is not a number
                // bNumber := false;
                 MessageDlg('The value entered as time is not a number.',mtError, [mbOk], 0);
                 Exit;
            end;
       end;
  end;
  //reaching here means time entry has been successfully entered as a number
  sTeam := edtTeam.Text;
  rNewTime := StrToFloat(edtTime.Text);
  //Question 2.2.2
  btnCheckRecord  := TButton.Create(grpQ22);
  btnCheckRecord.Parent := grpQ22;
  btnCheckRecord.Left :=  72;
  btnCheckRecord.Top := 158;
  btnCheckRecord.Height := 55;
  btnCheckRecord.Width := 235;
  btnCheckRecord.Caption := 'Check Record';
  btnCheckRecord.OnClick := btnCheckStatus;
end;

procedure TfrmQuestion2.btnCheckStatus(Sender: TObject);
begin
  Boys19Relay.checkForRecord(edtTeam.Text, StrToFloat(edtTime.Text));
  redOutput.Clear;
  redOutput.lines.Add(Boys19Relay.ToString);
  btnRecordStatus.Enabled := true;
end;

procedure TfrmQuestion2.btnRecordStatusClick(Sender: TObject);
var
 sOutputString : String;
begin
  //Question 2.2.3
 if (Boys19Relay.getYear = '2013' ) OR  (Boys19Relay.getYear = '2014') then
     sOutputString := #13 + 'Recent record'
 else
    sOutputString := #13 + 'Old record';
  redOutput.lines.Add(sOutputString);
end;

procedure TfrmQuestion2.btnCloseClick(Sender: TObject);
begin
  Application.Terminate
end;

end.
