unit RelayEvent_UMemo;

interface

type
   TRelayEvent = class(TObject)
   private
        fEvent : String;
        fTeam  : String;
        fYear  : String;
        fRecordTime : real;
   public
        constructor Create(sItem, sTeam, sYear : String; rRecTime : real);
        function getTeam  : String;
        function getEvent : String;
        function getYear  : String;
        function getRecordTime : real;
        procedure checkForRecord(sNewTeam : String; rNewTime : real);
        function toString : String;
end;

implementation
uses SysUtils, DateUtils;

{ TRelayItem }

constructor TRelayEvent.Create(sItem, sTeam, sYear: String; rRecTime: real);
begin
   fEvent   := sItem;
   fTeam    := sTeam;
   fYear    := sYear;
   fRecordTime := rRecTime;
end;

procedure TRelayEvent.checkForRecord(sNewTeam: String; rNewTime: real);
begin
   if rNewTime < fRecordTime then
     begin
       fTeam  := sNewTeam;
       fYear  := IntToStr(YearOf(Today()));
       fRecordTime := rNewTime;
     end
    else
     if rNewTime = fRecordTime then
       begin
         fTeam := fTeam + '; ' + sNewTeam;
         fYear  := fYear + '; ' + IntToStr(YearOf(Today()));
         //record time does not change
       end;
end;

function TRelayEvent.getEvent: string;
begin
  result := fEvent;
end;

function TRelayEvent.getRecordTime: real;
begin
     Result := fRecordTime;
end;

function TRelayEvent.getTeam: String;
begin
   result := fTeam;
end;

function TRelayEvent.getYear: String;
begin
   result := fYear;
end;

function TRelayEvent.toString: String;
begin
   Result := 'Current record information for ' + fEvent + #13 + #13+
             'Team: ' + fTeam + #13 +
             'Year: ' + fYear + #13 +
             'Time: ' + FloatToStrF(fRecordTime, ffFixed, 5,2);
end;


end.
