unit Question3_UMemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmQuestion3 = class(TForm)
    grpReports: TGroupBox;
    grpQ31: TGroupBox;
    grpQ32: TGroupBox;
    grpQ33: TGroupBox;
    grpSchReport: TGroupBox;
    GroupBoxSelectSchool: TGroupBox;
    btnDisplayReport: TButton;
    cmbSchool: TComboBox;
    btnAverageResults: TButton;
    btnSwapPoints: TButton;
    redOutput: TRichEdit;
    lblHeading: TLabel;
    btnClose: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnDisplayReportClick(Sender: TObject);
    procedure cmbSchoolChange(Sender: TObject);
    procedure btnAverageResultsClick(Sender: TObject);
    procedure btnSwapPointsClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  frmQuestion3: TfrmQuestion3;

implementation

{$R *.dfm}
 var
    arrSchoolNames : array[1..8] of String = ('Bedworthpark High School', 'Bristol House', 'Broadlands Technical High', 'Griffiths House', 'Fenham College', 'Edenburgh High School', 'Rethanda College', 'Sheffield High School');
    arrSchoolAbrv  : array[1..8] of String = ('BPK', 'BSL', 'BRT', 'GFH', 'FNH', 'EDB' , 'RTN', 'SFD'  );
    arrResults : array[1..8,1..4] of integer = ((365,458,214,0),(255,125,128,0),(489,499,478,0),(211,212,256,0),(356,345,387,0),(479,508,479,0),(259,245,287,0),(302,315,354,0));
    arrBoys : array[1..8] of integer;
    arrGirls : array[1..8] of integer;
    tempResults : array[1..8,1..4] of integer = ((0,0,0,0),(0,0,0,0),(0,0,0,0),(0,0,0,0),(0,0,0,0),(0,0,0,0),(0,0,0,0),(0,0,0,0));

procedure TfrmQuestion3.FormCreate(Sender: TObject);
var
  iCounter : integer;
begin
   //populate school combo box
  for iCounter := 1 to 8 do
  begin
      cmbSchool.Items.Add(arrSchoolAbrv[iCounter]);
  end;//for
end;

procedure TfrmQuestion3.btnDisplayReportClick(Sender: TObject);
var
  K, iPlace: integer;
  TFile : TextFile;
  sLine, sSchool, sSchoolAbrv, sSAbrv : String;
  sGender : String;
const
   sFileName = 'Results.txt';
begin
redOutput.Lines.Clear;
redOutput.Paragraph.TabCount := 4;
redOutput.Paragraph.Tab[0]   := 100;
redOutput.Paragraph.Tab[1]   := 200;
redOutput.Paragraph.Tab[2]   := 300;
redOutput.Paragraph.Tab[3]   := 400;

sSchoolAbrv := cmbSchool.Text;
sSchool := arrSchoolNames[cmbSchool.ItemIndex + 1];
redOutput.Lines.Add('School: ' + sSchool +  '  (' + sSchoolAbrv + ')');
redOutput.Lines.Add('Place' + #9 + 'Boys' + #9 + 'Girls' +  #9 + 'Total');

  for K := 1 to 8 do
   begin
     arrBoys[K] := 0;
     arrGirls[K] := 0;
   end;

  try
  if NOT FileExists(sFileName)then
    begin
       MessageDlg('The file does not exists.', mtWarning, [mbOk],0);
       Exit;
    end;
  AssignFile(TFile, sFileName);
  Reset(TFile);
  While NOT EOF (TFile) do
    begin
      Readln(TFile, sLine);   //71;Javelin-BSL#Boys u/15;7
      sSAbrv := copy(sLine,pos('#',sLine) - 3, 3);
      sGender := copy(sLine,pos('-',sLine) + 1,1) ;
      iPlace := StrToInt(sLine[length(sLine)]);    // last character
      if (sSAbrv = sSchoolAbrv) then
       if (sGender = 'B')  then
           inc(arrBoys[iPlace])
        else
           inc(arrGirls[iPlace]);
    end; //e while
  finally
   CloseFile(TFile);
  end;
   for K := 1 to 8 do
     redOutput.Lines.Add(IntToStr(K) + #9 + IntToStr(arrBoys[K]) + #9 + IntToStr(arrGirls[K]) +  #9 + IntToStr(arrBoys[K] + arrGirls[K]));
end;

procedure TfrmQuestion3.cmbSchoolChange(Sender: TObject);
begin
  btnDisplayReport.Enabled := true;
  redOutput.Lines.Clear;
  redOutput.Lines.Add('Place' + #9 + 'Boys' + #9 + 'Girls' +  #9 + 'Total');
end;

procedure TfrmQuestion3.btnAverageResultsClick(Sender: TObject);
var
  iCol, iRow, iTotal : integer;
  iAverage,iHighestAverage : integer;
  sLine : String;
begin
  redOutput.Clear;
  redOutput.Paragraph.TabCount := 5;
  redOutput.Paragraph.Tab[0]   := 80;
  redOutput.Paragraph.Tab[1]   := 180;
  redOutput.Paragraph.Tab[2]   := 280;
  redOutput.Paragraph.Tab[3]   := 380;
  redOutput.Paragraph.Tab[4]   := 480;
  redOutput.Lines.Add('Results of schools over three years');
  iHighestAverage := 0;
  for iCol := 1 to 8 do
     begin
      iTotal := 0;
      for iRow := 1 to 3 do
        iTotal := iTotal + arrResults[iCol][iRow];
      iAverage :=  Trunc(iTotal / 3);

      arrResults[iCol][4] := iAverage;
      if iHighestAverage < iAverage then
        iHighestAverage := iAverage;
     end;   // for iCol

    redOutput.Lines.Add(' ' + #9 + '2012' + #9 + '2013' +  #9 + '2014'+  #9 + 'Average points');
    for iCol := 1 to 8 do
      begin
        if arrResults[iCol][4] = iHighestAverage then
            arrSchoolAbrv[iCol]  := arrSchoolAbrv[iCol] + '*';
        sLine := arrSchoolAbrv[iCol];
        for iRow := 1 to 4 do
          sLine := sLine + #9 + IntToStr(arrResults[iCol][iRow]);
      redOutput.Lines.Add(sLine);
      end; // for
end;

procedure TfrmQuestion3.btnSwapPointsClick(Sender: TObject);
var
  K :integer;
begin
  for K := 1 to 4 do
     tempResults[1][K] := arrResults[1][K];
  arrResults[1] := arrResults[2];
  for K := 1 to 4 do
     arrResults[2][K] := tempResults[1][K];
  btnAverageResults.Click;
end;

procedure TfrmQuestion3.btnCloseClick(Sender: TObject);
begin
  Application.Terminate;
end;

end.
